-----------------------------------------------------------------
--         aPLib v0.22b  -  the smaller the better :)          --
--                                                             --
--   Copyright (c) 1998-99 by  - Jibz -  All Rights Reserved   --
--                                                             --
--   Ada binding: Gautier.deMontmollin@Maths.UniNe.CH          --
-----------------------------------------------------------------

generic
  type packed_data is private;
  type unpacked_data is private;
  with procedure Call_back(unpacked, packed: integer; continue: out boolean);

package aPLib is

  procedure Pack(source: unpacked_data;
                 destination: out packed_data;
                 packed_length: out integer);

  procedure Depack(source: packed_data; destination: out unpacked_data);

  pack_failed, unpack_failed: exception;

end aPLib;