;***************************************************************
;*         aPLib v0.22b  -  the smaller the better :)          *
;*           NASM 16bit assembler depacker example             *
;*                                                             *
;*   Copyright (c) 1998-99 by  - Jibz -  All Rights Reserved   *
;*    -> 16bit    METALBRAIN (metalb@www.esi.us.es)            *
;***************************************************************

                org     256
                cld
                mov     si,129          ;Arguments from PSP start here
                push    ds              ;Save ds for final restore
                pop     ax
                mov     [dataseg],ax
                mov     di,testitnow
space1:         call    di
                jz      space1
                dec     si
                mov     dx,si
space2:         call    di
                jnz     space2
                mov     [si-1],dh
space3:         call    di
                jz      space3
                dec     si
                mov     [nameout],si
space4:         lodsb
                cmp     al,13
                jz      nospace4
                cmp     al," "
                jnz     space4
nospace4:       mov     [si-1],dh
                mov     ax,3d00h
                int     33              ;Open infile
                jnc     not_error001
                call    final
                db "Can't open infile$"
not_error001:   stosw
                mov     dx,tmpname
                xor     cx,cx
                mov     ah,3ch
                int     33              ;Open temporal outfile
                jnc     not_error007
                call    final
                db "Can't open temporal outfile$"
not_error007:   stosw                   ;Temporal outfile handle
                xchg    ax,dx
                xor     ebx,ebx
                mov     bx,inbuff
                mov     esp,ebx
                mov     bx,es
                add     bh,8
                imul    eax,ebx,byte 16
                add     eax,esp
                push    dx
                mov     dl,128
                stosd
                stosd
                stosd
                add     [di-2],byte 2
                xchg    eax,edi
                add     [origin32+1],dx
                mov     esi,edi
                push    edi             ;Starting point for DEPACK16
literal:        call    getesi
putedi_nexttag: call    putedi
                call    newtest
                jmp     short nexttag
normalcodepair: xchg    ax,cx
                shl     eax,8
                call    getesi
                call    getgamma
                cmp     eax,32000
                jae     domatch_with_2inc
                cmp     eax,1280
                jae     domatch_with_inc
                cmp     eax,byte 127
                ja      domatch
domatch_with_2inc:
                inc     ecx
domatch_with_inc:
                inc     ecx
domatch:        xchg    eax,ebp
domatch_R0:     mov     eax,ebp
domatch_continue:
                push    esi
                mov     esi,edi
                sub     esi,eax
                cmp     esi,[freemem32]
                jc      near badinfile
repmovsb:       call    dontread
                call    putedi
                mov     ah,128
                call    newtest
                loop    repmovsb,ecx
                pop     esi
nexttag:        call    getbit
                jnc     literal
                xor     ecx,ecx
                xor     ax,ax
                call    getbit
                jnc     codepair
                call    getbit
                jnc     shortmatch
                mov     al,16
                inc     cx
getmorebits:    call    getbit
                adc     al,al
                jnc     getmorebits
                jnz     domatch_continue
                jmp     short putedi_nexttag
codepair:       call    getgamma
                sub     cx,byte 3
                jnc     normalcodepair
                inc     cx
                push    word domatch_R0
getgamma:       inc     cx
getgammaloop:   call    getbit
                adc     ecx,ecx
                call    getbit
                jc      getgammaloop
                ret
shortmatch:     call    getesi
                shr     ax,1
                jz      donedepacking
                adc     cx,cx
                jmp     short domatch_with_2inc
getbit:         add     dl,dl
                jnz     stillbitsleft
                xchg    ax,dx
                call    getesi
                xchg    ax,dx
                stc
                adc     dl,dl
stillbitsleft:  ret
donedepacking:  pop     esi
                pop     bx
                sub     edi,esi         ;And here finish DEPACK 16
                push    ds
                mov     ch,0fah
more:           cmp     edi,ecx
                ja      notlast
                mov     cx,di
notlast:        push    esi
                pop     dx
                pop     ax
                ror     ax,4
                mov     ds,ax
                add     esi,ecx
                call    writefile
                sub     edi,ecx
                ja      more
                pop     ds
                push    ds
                pop     es
                mov     dx,[nameout]
                call    close_del
                jnc     renameit
                cmp     ax,5
                jz      error002b
renameit:       mov     ah,56h
                mov     di,dx
                mov     dx,tmpname
                int     33              ;Rename temporal outfile to outfile
                jc      error002        ;Can't open outfile
                push    word noerr
final:          mov     dx,[dataseg]
                mov     ds,dx
                pop     dx
final_dxok:     mov     ah,9
                int     33              ;Show final message
                int     20h             ;Exit program
writefile:      mov     ah,40h          ;Write outfile
                int     33
                jc      error005        ;Can't write
                and     ax,ax
                jz      error006        ;Disk is full
                ret
error002b:      push    word err002b
                jmp     short rub3
error002:       push    word err002
                jmp     short rub4
error005:       push    word err005
                jmp     short rub3
error006:       push    word err006
rub3:           mov     dx,tmpname
rub4:           push    word final
close_del:      mov     ah,3eh
                int     33
                mov     ah,41h
                int     33
                ret
getesi:         cmp     esi,[freemem32]
                jnz     dontread
                pusha
                mov     ah,3fh
                mov     bx,[handlein]
                mov     cx,32768
                mov     dx,inbuff
                int     33
                jc      error003
noerror003:     test    ax,ax
                jnz     noerror004
badinfile:      push    word err004
                jmp     short error004
error003:       push    word err003
error004:       mov     bx,[handletmp]
                jmp     short rub3
noerror004:     popa
                sub     esi,32768
dontread:       push    esi
                pop     bx
                pop     bx
                ror     bx,4
                mov     es,bx
                mov     al,[es:si]
                inc     esi
                ret
newtest:        cmp     edi,[limit32]
                jc      endtest
                pushad
                mov     dx,freemem
                mov     cx,32768
                mov     bx,[handletmp]
                call    writefile
                mov     ecx,edi
                mov     esi,[origin32]
                sub     ecx,esi
                mov     edi,[freemem32]
otherrepmovsb:  call    getesi
                call    putedi
                loop    otherrepmovsb,ecx
                popad
                sub     esi,eax
                mov     ah,128
                sub     edi,eax
endtest:        ret
putedi:         push    edi
                pop     bx
                pop     bx
                ror     bx,4
                mov     es,bx
                mov     [es:di],al
                inc     edi
                xor     eax,eax
                ret
err000:         db "Usage: DEPPACK infile outfile",13,10,10
                db "infile must be an aPPACKed file",13,10
                db "wildcards are not allowed",13,10,10
                db "DEPPACK v0.3 Copyright (c) 1998-99 by  METALBRAIN",13,10
                db "aPLib v0.22b Copyright (c) 1998-99 by  - Jibz -  All Rights Reserved$"
err005:         db "Can't write temporal outfile$"
err002b:        db "Outfile is protected, so...",13,10
err002:         db "Can't open outfile$"
err003:         db "Can't read from infile$"
err004:         db "Bad infile$"
err006:         db "Disk full$"
noerr:          db "Deppacking ok$"
error000:       push    word err000
                jmp     final
tmpname:        db "",0

testitnow:      lodsb
                cmp     al,13
                jz      error000
                cmp     al,32
                ret
handlein        EQU     testitnow
handletmp:      EQU     testitnow+2
freemem32:      EQU     testitnow+4
origin32:       EQU     testitnow+8
limit32:        EQU     testitnow+12
                SECTION .bss align=1
                RESD 2
nameout:        RESW 1
dataseg:        RESW 1
                RESW 80                 ;Stack
inbuff:         RESB 32768              ;Infile reading buffer
freemem:
