;***************************************************************
;*         aPLib v0.22b  -  the smaller the better :)          *
;*         NASM 16bit assembler tiny depacker example          *
;*                                                             *
;*   Copyright (c) 1998-99 by  - Jibz -  All Rights Reserved   *
;*    -> 16bit    METALBRAIN (metalb@www.esi.us.es)            *
;***************************************************************

                org     256
                cld
start:          mov     si,129          ;Arguments from PSP start here
                mov     di,testitnow
space1:         call    di
                jz      space1
                dec     si
                mov     dx,si
space2:         call    di
                jnz     space2
                mov     [si-1],dh
space3:         call    di
                jz      space3
                dec     si
                mov     [nameout],si
space4:         lodsb
                cmp     al," "
                ja      space4
nospace4:       mov     [si-1],dh
                mov     ax,3d00h
                int     33              ;Open infile
                jc      finerr00
                stosw
                mov     dx,tmpname
                xor     cx,cx
                mov     ah,3ch
                int     33              ;Open temporal outfile
                jnc     nofinerr        ;Can't open temporal outfile
finerr00:       jmp     finerr
nofinerr:       stosw                   ;Temporal outfile handle
                xchg    ax,dx
                xor     ebx,ebx
                mov     bx,inbuff
                mov     esp,ebx
                mov     bx,es
                add     bh,8
                imul    eax,ebx,byte 16
                add     eax,esp
                push    dx
                mov     dl,128
                stosd
                stosd
                stosd
                add     [di-2],byte 2
                xchg    eax,edi
                add     [origin32+1],dx
                mov     esi,edi
                push    edi             ;Starting point for DEPACK16
literal:        call    getesi
putedi_nexttag: call    putedi
                call    newtest
                jmp     short nexttag
normalcodepair: xchg    ax,cx
                shl     eax,8
                call    getesi
                call    getgamma
                cmp     eax,32000
                jae     domatch_with_2inc
                cmp     eax,1280
                jae     domatch_with_inc
                cmp     eax,byte 127
                ja      domatch
domatch_with_2inc:
                inc     ecx
domatch_with_inc:
                inc     ecx
domatch:        xchg    eax,ebp
domatch_R0:     mov     eax,ebp
domatch_continue:
                push    esi
                mov     esi,edi
                sub     esi,eax
                cmp     esi,[freemem32]
                jc      finerr00
repmovsb:       call    dontread
                call    putedi
                mov     ah,128
                call    newtest
                loop    repmovsb,ecx
                pop     esi
nexttag:        call    getbit
                jnc     literal
                xor     ecx,ecx
                xor     ax,ax
                call    getbit
                jnc     codepair
                call    getbit
                jnc     shortmatch
                mov     al,16
                inc     cx
getmorebits:    call    getbit
                adc     al,al
                jnc     getmorebits
                jnz     domatch_continue
                jmp     short putedi_nexttag
codepair:       call    getgamma
                sub     cx,byte 3
                jnc     normalcodepair
                inc     cx
                push    word domatch_R0
getgamma:       inc     cx
getgammaloop:   call    getbit
                adc     ecx,ecx
                call    getbit
                jc      getgammaloop
                ret
shortmatch:     call    getesi
                shr     ax,1
                jz      donedepacking
                adc     cx,cx
                jmp     short domatch_with_2inc
getbit:         add     dl,dl
                jnz     stillbitsleft
                xchg    ax,dx
                call    getesi
                xchg    ax,dx
                stc
                adc     dl,dl
stillbitsleft:  ret
donedepacking:  pop     esi
                pop     bx
                sub     edi,esi         ;And here finish DEPACK 16
                push    ds
                mov     ch,0fah
more:           cmp     edi,ecx
                ja      notlast
                mov     cx,di
notlast:        push    esi
                pop     dx
                pop     ax
                ror     ax,4
                mov     ds,ax
                add     esi,ecx
                call    writefile
                sub     edi,ecx
                ja      more
                pop     ds
                push    ds
                pop     es
                mov     dx,[nameout]
                call    close_del
                jnc     renameit
                cmp     ax,5
                jz      finerr
renameit:       mov     ah,56h
                mov     di,dx
                mov     dx,tmpname
                int     33              ;Rename temporal outfile to outfile
                jc      finerr          ;Can't open outfile
                mov     dx,noerr
final_dxok:     mov     ah,9
                int     33              ;Show final message
                int     20h             ;Exit program
writefile:      mov     ah,40h          ;Write outfile
                int     33
                jc      finerr          ;Can't write
                and     ax,ax
                jnz     not_finerr      ;Disk is full
finerr:         mov     dx,tmpname
                push    word final_dxok
close_del:      mov     ah,3eh
                int     33              ;Close temporal outfile
                mov     ah,41h
                int     33              ;Delete outfile
not_finerr:     ret
getesi:         cmp     esi,[freemem32]
                jnz     dontread
                pusha
                mov     ah,3fh
                mov     bx,[handlein]
                mov     cx,32768
                mov     dx,inbuff
                int     33
finerr01:       jc      finerr          ;Can't read from infile
                popa
                sub     esi,32768
dontread:       push    esi
                pop     bx
                pop     bx
                ror     bx,4
                mov     es,bx
                mov     al,[es:si]
                inc     esi
                ret
newtest:        cmp     edi,[limit32]
                jc      endtest
                pushad
                mov     dx,freemem
                mov     cx,32768
                mov     bx,[handletmp]
                call    writefile
                mov     ecx,edi
                mov     esi,[origin32]
                sub     ecx,esi
                mov     edi,[freemem32]
otherrepmovsb:  call    getesi
                call    putedi
                loop    otherrepmovsb,ecx
                popad
                sub     esi,eax
                mov     ah,128
                sub     edi,eax
endtest:        ret
putedi:         push    edi
                pop     bx
                pop     bx
                ror     bx,4
                mov     es,bx
                mov     [es:di],al
                inc     edi
                xor     eax,eax
                ret
tmpname:
errmes:         db      "NOT "
noerr:          db      "OK$",0

testitnow:      lodsb
                cmp     al,14
                jc      finerr01
                cmp     al,32
                ret
handlein        EQU     testitnow
handletmp:      EQU     testitnow+2
freemem32:      EQU     testitnow+4
origin32:       EQU     testitnow+8
limit32:        EQU     testitnow+12
                SECTION .bss align=1
                RESD 2
nameout:        RESW 1
dataseg:        RESW 1
                RESW 80                 ;Stack
inbuff:         RESB 32768              ;Infile reading buffer
freemem:
